local mod = RW:Boss("Baron Geddon", "Classic" , "Molten Core")
local L

mod.BossIcon = [[Interface\Icons\achievement_boss_ragnaros]]

---------------------------
-- Variables

-- Inferno
local tInfernoDur, wInferno

-- Bomb
local tBombDur, wBomb, mBomb, iBomb

-- Ignite
local mIgnite

local RoleBits = RW.Utils.Constants.RoleBits

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		
	end
	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(12056)
	self:SetWin(12056)
	
	-- Inferno
	tInfernoDur		= self:DurTimer(8, 19695)
	wInferno		= self:RunawayWarning(19695, nil, nil, bit.bor(RoleBits.MELEE, RoleBits.TANK))
	
	-- Bomb
	tBombDur		= self:DurTargetTimer(8, 20475)
	wBomb			= self:RunawayWarning(20475)
	mBomb			= self:TargetMessage(20475)
	iBomb			= self:Icon("SKULL", 20475, false, 9)
	
	-- Ignite
	mIgnite			= self:TargetMessage(19659)
end

---------------------------
-- Locals

-- API Functions

function mod:OnEngage(trigger)
	self:Track("Inferno", 19695)
	self:Track("Bomb", 20475)
	self:Track("Ignite", 19659)
end

function mod:Inferno(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		tInfernoDur:Start()
		wInferno:Show()
	end
end

function mod:Bomb(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if args:IsPlayer() then
			wBomb:Show()
		end
		tBombDur:Start(args.dName)
		mBomb:Show(args.dName)
		iBomb:Show(args.dName)
	end
end

function mod:Ignite(event, args)
	if event == "SPELL_AURA_APPLIED" then
		mIgnite:Show(args.dName)
	end
end
