local mod = RW:Boss("Lucifron", "Classic" , "Molten Core")
local L

mod.BossIcon = [[Interface\Icons\achievement_boss_ragnaros]]

---------------------------
-- Variables

-- MC
local tMCDur, mMC, iMC

-- Doom
local tDoomCD, tDoomDur, wDoom

-- Curse
local tCurseCD, wCurse

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		
	end
	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(12118)
	self:SetWin(12118)
	
	-- MC
	tMCDur		= self:DurTargetTimer(20, 15859)
	mMC			= self:TargetMessage(15859)
	iMC			= self:Icon("SKULL", 15859, nil, 15, "STAR", "CIRCLE", "MOON") 
	
	-- Doom
	tDoomCD		= self:CDTimer(20, 19702)
	tDoomDur	= self:DurTimer(10, 19702)
	wDoom		= self:CastWarning(19702)
	
	-- Curse
	tCurseCD	= self:CDTimer(20, 19703)
	wCurse		= self:CastWarning(19703)
end

---------------------------
-- Locals

-- API Functions

function mod:OnEngage(trigger)
	self:Track("Dominate", 15859)
	self:Track("Doom", 19702)
	self:Track("Curse", 19703)
end

function mod:Dominate(event, args)
	if event == "SPELL_AURA_APPLIED" then
		tMCDur:Start(args.dName)
		mMC:AddDelayTarget(args.dName)
		mMC:DelayedShow(0.3)
		iMC:Show(args.dName)
	
	elseif event == "SPELL_AURA_REMOVED" then
		tMCDur:Stop(args.dName)
		iMC:Hide(args.dName)
	end
end

function mod:Doom(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		wDoom:Show()
		tDoomCD:Start()
		tDoomDur:Start()
	end
end

function mod:Curse(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		tCurseCD:Start()
		wCurse:Show()
	end
end
